## libjjml-java 1.1.12

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project("argeo-jjml"
DESCRIPTION "Enterprise-grade Java bindings for GGML-based libraries"
)
set(A2_JAVA_RELEASE 11)
set(A2_CATEGORY org.argeo.jjml)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/sdk/argeo-build/cmake")
find_package(ArgeoBuild)

# JAVA
set(BUNDLES 
org.argeo.jjml
)

a2_build_bundles(${BUNDLES})

add_subdirectory(native)

=== native/CMakeLists.txt ===
#
# OPTIONS
#
option(JJML_FORCE_BUILD_TP "Force build of reference third-party submodules even if they are available on the system")
option(JJML_DO_NOT_BUILD_TP "Fail if third-party libraries are not found, instead of building them from the reference submodules")
option(JJML_JDK_TP "Use third-party environment provided by a ggml-instrumented JDK (useful for Windows)")

#
# THIRD PARTY DETECTION
#
#set(CMAKE_FIND_DEBUG_MODE ON)

if(NOT JJML_FORCE_BUILD_TP)

if(NOT MSVC)
# Debian official until libraries are stable
set(CMAKE_PREFIX_PATH
/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/ggml/cmake-private
/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/llama/cmake-private
)
endif()

if(JJML_JDK_TP) # Use environment provided by a ggml-instrumented JDK
	set(CMAKE_LIBRARY_PATH ${JAVA_HOME}/bin ${JAVA_HOME}/lib)
	include_directories(${JAVA_HOME}/include SYSTEM)
endif()

# look for llama.cpp via CMake configs (preferred)
find_package(llama QUIET)
if(llama_FOUND)
	message(STATUS "Found llama.cpp and ggml packages: ${llama_LIBRARY} ${GGML_LIBRARY} ${GGML_BASE_LIBRARY}")
else()
	# look for llama.cpp via simple library search
	find_library(llama_LIBRARY llama)
	
	# look for ggml via CMake configs (preferred)
	find_package(ggml QUIET)
	if(ggml_FOUND)
		message(STATUS "Found ggml package: ${GGML_LIBRARY} ${GGML_BASE_LIBRARY}")
	else()
		# look for ggml via simple library search
		find_library(GGML_LIBRARY ggml)
		find_library(GGML_BASE_LIBRARY ggml-base)
	endif()
endif()
	
endif() # JJML_FORCE_BUILD_TP

if(EXISTS ${GGML_LIBRARY}) # ggml as external libraries
	if(NOT ggml_FOUND) # not CMake configured
		add_library(ggml SHARED IMPORTED GLOBAL)
		if(MSVC)
		set_target_properties(ggml PROPERTIES IMPORTED_IMPLIB ${GGML_LIBRARY})
		else()
		set_target_properties(ggml PROPERTIES IMPORTED_LOCATION ${GGML_LIBRARY})
		endif()
		
		add_library(ggml-base SHARED IMPORTED GLOBAL)
		if(MSVC)
		set_target_properties(ggml-base PROPERTIES IMPORTED_IMPLIB ${GGML_BASE_LIBRARY})
		else()
		set_target_properties(ggml-base PROPERTIES IMPORTED_LOCATION ${GGML_BASE_LIBRARY})
		endif()
		message(STATUS "Found ggml libraries: ${GGML_LIBRARY} ${GGML_BASE_LIBRARY}")
	endif()
	
	if(NOT DEFINED GGML_BACKEND_DL)
		include(CheckIncludeFileCXX)
		check_include_file_cxx(ggml-backend.h JJML_BACKEND_INCLUDE_FOUND)
		if(JJML_BACKEND_INCLUDE_FOUND)
			set(GGML_BACKEND_DL ON)
			message(STATUS "Found ggml-backend.h, enabling GGML_BACKEND_DL")
		endif()
	endif()
endif()

if(EXISTS "${llama_LIBRARY}") # llama.cpp as external library
	if(NOT llama_FOUND) # not CMake configured
		add_library(llama SHARED IMPORTED GLOBAL)
		if(MSVC)
		set_target_properties(llama PROPERTIES IMPORTED_IMPLIB ${llama_LIBRARY})
		else()
		set_target_properties(llama PROPERTIES IMPORTED_LOCATION ${llama_LIBRARY})
		endif()
		target_link_libraries(llama INTERFACE ${GGML_LIBRARY})
		message(STATUS "Found LLAMA library: ${llama_LIBRARY}") 
	endif()
endif()

if(NOT JJML_DO_NOT_BUILD_TP)
	# Build reference third-party submodules if needed
	add_subdirectory(tp)
endif()

message(STATUS "GGML_BUILD_NUMBER=${GGML_BUILD_NUMBER} LLAMA_BUILD_NUMBER=${LLAMA_BUILD_NUMBER}")

#
# JJML NATIVE BUILD
#
if(GGML_BACKEND_DL)
	message(STATUS "Build JNI libraries with support for dynamic ggml backends") 
endif()

# Force ISO C++
if (MSVC)
add_compile_options(/permissive-)
else()
add_compile_options(-pedantic-errors)
endif()

# JNI shared libraries
add_subdirectory(org_argeo_jjml_ggml)
add_subdirectory(org_argeo_jjml_llm)

=== native/org_argeo_jjml_ggml/CMakeLists.txt ===
set(TARGET Java_org_argeo_jjml_ggml)

add_library(${TARGET} SHARED 
	jjml_ggml_backend.cpp
)

if(ggml_FOUND)
target_link_libraries(${TARGET} PRIVATE	ggml::ggml)
else()
target_link_libraries(${TARGET} PRIVATE	ggml)
endif()

if (GGML_BACKEND_DL)
    target_compile_definitions(${TARGET} PRIVATE GGML_BACKEND_DL)
endif()
	
a2_jni_target(${TARGET})

=== native/org_argeo_jjml_llm/CMakeLists.txt ===
set(TARGET Java_org_argeo_jjml_llm)

add_library(${TARGET} SHARED 
	org_argeo_jjml_llm_.cpp
	jjml_llm.cpp
	jjml_llm_vocabulary.cpp
	jjml_llm_model.cpp
	jjml_llm_chat.cpp
	jjml_llm_context.cpp
	jjml_llm_sampling.cpp
	jjml_llm_batch_write.cpp
	jjml_llm_batch_read.cpp
	jjml_llm_embedding.cpp
)

if(ggml_FOUND)
target_link_libraries(${TARGET} PRIVATE	ggml::ggml ggml::ggml-base llama)
else()
target_link_libraries(${TARGET} PRIVATE	ggml ggml-base llama)
endif()

# When breaking changes are not functionally critical
# we keep building against older, in order to extend the life
# of a given JJML branch. To be trimmed when a new branch
# is created.

if(LLAMA_BUILD_NUMBER LESS 6325)
# Breaks flash attention context parameters
target_compile_definitions(${TARGET} PRIVATE JJML_PRE_LLAMA_0_0_6325)
endif()

if(LLAMA_BUILD_NUMBER LESS 5913)
# Introduce kv_unified context parameter
target_compile_definitions(${TARGET} PRIVATE JJML_PRE_LLAMA_0_0_5913)
endif()

if(LLAMA_BUILD_NUMBER LESS 5882)
# KV cache API change
target_compile_definitions(${TARGET} PRIVATE JJML_PRE_LLAMA_0_0_5882)
endif()

if(LLAMA_BUILD_NUMBER LESS 4881)
# KV cache API change
target_compile_definitions(${TARGET} PRIVATE JJML_PRE_LLAMA_0_0_4881)
endif()

a2_jni_target(${TARGET})

=== native/tp/CMakeLists.txt ===
#
# BUILD THIRD PARTY FROM SUBMODULES
#

if(GGML_BACKEND_DL)
set(BUILD_SHARED_LIBS ON)
endif()

set(TARGET_NATIVE_OUTPUT_GGML ${A2_OUTPUT}/lib/${TARGET_NATIVE_CATEGORY_PREFIX}/org.argeo.tp.ggml)
set(TARGET_NATIVE_OUTPUT_LLAMA ${TARGET_NATIVE_OUTPUT_GGML})

# All CPU variants backends take the default output directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_GGML}>)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_GGML}>)

if(MINGW)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_GGML}>)
elseif(MSVC)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_GGML}>)
else()
endif()

if(NOT EXISTS ${GGML_LIBRARY})
	## multiple backends libraries
	if(NOT DEFINED GGML_BACKEND_DL)
		set(GGML_BACKEND_DL ON)
		message(STATUS "Enabling GGML_BACKEND_DL by default")
	endif()
	if(GGML_BACKEND_DL)
		set(GGML_CPU_ALL_VARIANTS ON)
	endif()

	# build locally
	if(JJML_FORCE_BUILD_LLAMA_GGML)
	add_subdirectory(llama.cpp/ggml)
	else() # default
	add_subdirectory(ggml)
	endif()
	message(STATUS "Build ggml locally from submodule native/tp/ggml") 
endif()


if(NOT EXISTS "${llama_LIBRARY}")
	set(LLAMA_STANDALONE ON)
	add_subdirectory(llama.cpp) # build locally
	if(MINGW)
		set_target_properties(llama PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${TARGET_NATIVE_OUTPUT_LLAMA})
		if(LLAMA_BUILD_TOOLS)
			set_target_properties(mtmd PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${TARGET_NATIVE_OUTPUT_LLAMA})
		endif()
	elseif(MSVC)
		set_target_properties(llama PROPERTIES RUNTIME_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_LLAMA}>)
		if(LLAMA_BUILD_TOOLS)
			set_target_properties(mtmd PROPERTIES RUNTIME_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_LLAMA}>)
		endif()
	else()
		set_target_properties(llama PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${TARGET_NATIVE_OUTPUT_LLAMA})
		if(LLAMA_BUILD_TOOLS)
			set_target_properties(mtmd PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${TARGET_NATIVE_OUTPUT_LLAMA})
		endif()
	endif()
	if(LLAMA_BUILD_TOOLS)
		set_target_properties(llama-cli PROPERTIES RUNTIME_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_LLAMA}>)
	endif()
	message(STATUS "Build llama.cpp locally from submodule native/tp/llama.cpp") 
endif()

# ggml and llama.cpp versions
if (Git_FOUND)
execute_process(COMMAND "${GIT_EXECUTABLE}" rev-list --count HEAD
 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/ggml
 OUTPUT_VARIABLE JJML_GGML_COMMIT_COUNT OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND "${GIT_EXECUTABLE}" rev-list --count HEAD
 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/llama.cpp
 OUTPUT_VARIABLE JJML_LLAMA_COMMIT_COUNT OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()
if(NOT GGML_BUILD_NUMBER)
set(GGML_BUILD_NUMBER ${JJML_GGML_COMMIT_COUNT} CACHE INTERNAL GGML_BUILD_NUMBER)
endif()
if(NOT LLAMA_BUILD_NUMBER)
set(LLAMA_BUILD_NUMBER ${JJML_LLAMA_COMMIT_COUNT} CACHE INTERNAL LLAMA_BUILD_NUMBER)
endif()

=== debian/changelog ===
libjjml-java (1.1.12-1) unstable; urgency=medium

  * Update upstream

 -- Mathieu Baudier <mbaudier@argeo.org>  Wed, 01 Oct 2025 10:54:31 +0000

libjjml-java (1.1.11-2) unstable; urgency=medium

  * Initial Debian packaging

 -- Mathieu Baudier <mbaudier@argeo.org>  Sun, 21 Sep 2025 11:51:55 +0000

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# Both llama.cpp and the ggml it depends on are private for now
RPATH=/usr/lib/$(DEB_HOST_MULTIARCH)/ggml:/usr/lib/$(DEB_HOST_MULTIARCH)/llama

CMAKE_FLAGS = \
              -DJAVA_HOME=/usr/lib/jvm/default-java \
              -DCMAKE_INSTALL_RPATH=$(RPATH) \
              -DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF \
              -DCMAKE_BUILD_TYPE=RelWithDebInfo \

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_FLAGS)

execute_after_dh_auto_install-indep:
	ln -sr debian/tmp/usr/share/java/org.argeo.jjml-$(DEB_VERSION_UPSTREAM).jar \
	 debian/tmp/usr/share/java/org.argeo.jjml.jar

=== debian/watch ===
version=4
opts="mode=git" \
https://git.argeo.org/argeo-jjml refs/tags/([\d\.]+)

## libjjml-java 1.1.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project("argeo-jjml"
DESCRIPTION "Enterprise-grade Java bindings for the ggml ecosystem"
)
set(A2_CATEGORY org.argeo.jjml)

if(NOT DEFINED A2_JAVA_RELEASE)
set(A2_JAVA_RELEASE 11)
endif()

# Can build with headless JDK
set(JAVA_AWT_LIBRARY NotNeeded)
set(JAVA_AWT_INCLUDE_PATH NotNeeded)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/sdk/argeo-build/cmake")
find_package(ArgeoBuild)

# JAVA
set(BUNDLES 
org.argeo.jjml
)

a2_build_bundles(${BUNDLES})

add_subdirectory(native)

=== native/CMakeLists.txt ===
--- 
+++ 
@@ -65,6 +65,7 @@
 	endif()
 	
 	if(NOT DEFINED GGML_BACKEND_DL)
+			message(STATUS "## CHECK ###")
 		include(CheckIncludeFileCXX)
 		check_include_file_cxx(ggml-backend.h JJML_BACKEND_INCLUDE_FOUND)
 		if(JJML_BACKEND_INCLUDE_FOUND)

=== native/org_argeo_jjml_llm/CMakeLists.txt ===
set(TARGET Java_org_argeo_jjml_llm)

add_library(${TARGET} SHARED 
	org_argeo_jjml_llm_.cpp
	jjml_llm.cpp
	jjml_llm_vocabulary.cpp
	jjml_llm_model.cpp
	jjml_llm_chat.cpp
	jjml_llm_context.cpp
	jjml_llm_sampling.cpp
	jjml_llm_batch_write.cpp
	jjml_llm_batch_read.cpp
	jjml_llm_embedding.cpp
)

if(ggml_FOUND)
target_link_libraries(${TARGET} PRIVATE	ggml::ggml ggml::ggml-base llama)
else()
target_link_libraries(${TARGET} PRIVATE	ggml ggml-base llama)
endif()

# When breaking changes are not functionally critical
# we keep building against older, in order to extend the life
# of a given JJML branch. To be trimmed when a new branch
# is created.

# for example:
#if(LLAMA_BUILD_NUMBER LESS 6325)
## Breaks flash attention context parameters
#target_compile_definitions(${TARGET} PRIVATE JJML_PRE_LLAMA_0_0_6325)
#endif()

a2_jni_target(${TARGET})

=== native/tp/CMakeLists.txt ===
--- 
+++ 
@@ -22,12 +22,11 @@
 
 if(NOT EXISTS ${GGML_LIBRARY})
 	## multiple backends libraries
-	if(NOT DEFINED GGML_BACKEND_DL)
+	if(NOT DEFINED GGML_BACKEND_DL AND NOT DEFINED GGML_NATIVE AND NOT DEFINED GGML_CPU_ALL_VARIANTS)
 		set(GGML_BACKEND_DL ON)
-		message(STATUS "Enabling GGML_BACKEND_DL by default")
-	endif()
-	if(GGML_BACKEND_DL)
 		set(GGML_CPU_ALL_VARIANTS ON)
+		set(GGML_NATIVE OFF)
+		message(STATUS "Enabling GGML_BACKEND_DL with all CPU variants by default")
 	endif()
 
 	# build locally

=== sdk/argeo-build/Makefile ===
# WARNING: this Makefile is for Argeo Build to build itself
# and is not meant to be included or used in regular builds
include sdk.mk

# Tells Make.java that we are our own Argeo Build
export ARGEO_BUILD_CONFIG := .

A2_CATEGORY = org.argeo.build

BUNDLES = \
org.argeo.build \

DEP_CATEGORIES = \
log/syslogger/org.argeo.tp \
org.argeo.tp.build \

all: osgi
# copy generated MANIFEST
	cp org.argeo.build/META-INF/MANIFEST.MF META-INF/MANIFEST.MF
	rm -rf org.argeo.build 

clean:
	rm -rf $(BUILD_BASE)

include osgi.mk

=== debian/changelog ===
libjjml-java (1.1.13-1) unstable; urgency=medium

  * Upstream release
  * Fix 'arch:all' build

 -- Mathieu Baudier <mbaudier@argeo.org>  Sat, 08 Nov 2025 13:45:43 +0000

=== debian/control ===
Source: libjjml-java
Section: java
Priority: optional
Maintainer: Mathieu Baudier <mbaudier@argeo.org>
Standards-Version: 4.7.2
Vcs-Browser: http://git.argeo.org/?p=argeo-jjml;a=summary
Vcs-Git: https://git.argeo.org/argeo-jjml
Homepage: http://git.argeo.org/?p=argeo-jjml;a=summary
Build-Depends: cmake,
               default-jdk,
               debhelper-compat (= 13),
               libllama-dev,
Rules-Requires-Root: no

Package: libjjml-java
Architecture: all
Depends: libjjml-jni,
         ${misc:Depends},
Description: Java bindings for ggml libraries such as llama.cpp
 JJML provides enterprise-grade Java bindings for the llama.cpp
 LLM inference library.
 .
 Rather than to support all ggml and llama.cpp fatures, the main goal
 of this lightweight library is to be compatible with a broad range of
 Java versions (currently Java 11 to 25) and to provide a stable Java API
 for core LLM inference capabilities:
 .
  * Simple user/assistant dialog based on standard Java functional interfaces
  * Embeddings
  * Persistence of context state, in order to "pre-compile" prompt prefixes
  * Parallel batches
  * Chat templates (limited to those embedded in llama.cpp)
  * Combination and configuration of the native samplers from the Java side
  * API for implementing samplers in pure Java
 .
 This package contains the portable Java binaries, with OSGi and JPMS metadata.

Package: libjjml-jni
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Java bindings for ggml libraries such as llama.cpp (native libs)
 JJML provides enterprise-grade Java bindings for the llama.cpp
 LLM inference library.
 .
 This package contains the native libraries for libjjml-java.

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,7 @@
               -DCMAKE_INSTALL_RPATH=$(RPATH) \
               -DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF \
               -DCMAKE_BUILD_TYPE=RelWithDebInfo \
+              -DJJML_DO_NOT_BUILD_TP=ON \
 
 %:
 	dh $@ --buildsystem=cmake
@@ -17,6 +18,9 @@
 override_dh_auto_configure-arch:
 	dh_auto_configure -- $(CMAKE_FLAGS)
 
+override_dh_auto_configure-indep:
+	dh_auto_configure -- $(CMAKE_FLAGS)
+
 execute_after_dh_auto_install-indep:
 	ln -sr debian/tmp/usr/share/java/org.argeo.jjml-$(DEB_VERSION_UPSTREAM).jar \
 	 debian/tmp/usr/share/java/org.argeo.jjml.jar

## libjjml-java 1.1.18

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.14)
 
 project("argeo-jjml"
-DESCRIPTION "Enterprise-grade Java bindings for the ggml ecosystem"
+DESCRIPTION "Enterprise-grade Java bindings for the ggml ecosystem of machine learning libraries"
 )
 set(A2_CATEGORY org.argeo.jjml)

=== native/CMakeLists.txt ===
--- 
+++ 
@@ -94,6 +94,7 @@
 endif()
 
 message(STATUS "GGML_BUILD_NUMBER=${GGML_BUILD_NUMBER} LLAMA_BUILD_NUMBER=${LLAMA_BUILD_NUMBER}")
+message(STATUS "GGML_VERSION=${GGML_VERSION} LLAMA_VERSION=${LLAMA_VERSION}")
 
 #
 # JJML NATIVE BUILD

=== native/tp/CMakeLists.txt ===
--- 
+++ 
@@ -60,23 +60,59 @@
 	endif()
 	if(LLAMA_BUILD_TOOLS)
 		set_target_properties(llama-cli PROPERTIES RUNTIME_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_LLAMA}>)
+		set_target_properties(llama-bench PROPERTIES RUNTIME_OUTPUT_DIRECTORY $<1:${TARGET_NATIVE_OUTPUT_LLAMA}>)
 	endif()
 	message(STATUS "Build llama.cpp locally from submodule native/tp/llama.cpp") 
 endif()
 
 # ggml and llama.cpp versions
+
+# hack to retrieve GGML base version
+# see https://stackoverflow.com/a/15519607
+file(STRINGS ggml/CMakeLists.txt VersionSetter
+     REGEX "^[ ]*set\\(GGML_VERSION_MAJOR")
+string(REGEX REPLACE "(^[ ]*set\\(GGML_VERSION_MAJOR[ ]*)([^\\)]*)\\)" "\\2"
+       GGML_VERSION_MAJOR ${VersionSetter})
+file(STRINGS ggml/CMakeLists.txt VersionSetter
+     REGEX "^[ ]*set\\(GGML_VERSION_MINOR")
+string(REGEX REPLACE "(^[ ]*set\\(GGML_VERSION_MINOR[ ]*)([^\\)]*)\\)" "\\2"
+       GGML_VERSION_MINOR ${VersionSetter})
+file(STRINGS ggml/CMakeLists.txt VersionSetter
+     REGEX "^[ ]*set\\(GGML_VERSION_PATCH")
+string(REGEX REPLACE "(^[ ]*set\\(GGML_VERSION_PATCH[ ]*)([^\\)]*)\\)" "\\2"
+       GGML_VERSION_PATCH ${VersionSetter})
+
 if (Git_FOUND)
-execute_process(COMMAND "${GIT_EXECUTABLE}" rev-list --count HEAD
+execute_process(COMMAND "${GIT_EXECUTABLE}" describe --exact-match --tags
+ WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/ggml
+ OUTPUT_VARIABLE JJML_GGML_TAG OUTPUT_STRIP_TRAILING_WHITESPACE)
+if (NOT JJML_GGML_TAG)
+execute_process(COMMAND "${GIT_EXECUTABLE}" rev-list --count v${GGML_VERSION_MAJOR}.${GGML_VERSION_MINOR}.${GGML_VERSION_PATCH}..HEAD
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/ggml
  OUTPUT_VARIABLE JJML_GGML_COMMIT_COUNT OUTPUT_STRIP_TRAILING_WHITESPACE)
+endif()
 execute_process(COMMAND "${GIT_EXECUTABLE}" rev-list --count HEAD
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/llama.cpp
  OUTPUT_VARIABLE JJML_LLAMA_COMMIT_COUNT OUTPUT_STRIP_TRAILING_WHITESPACE)
 endif()
+
 if(NOT GGML_BUILD_NUMBER)
 set(GGML_BUILD_NUMBER ${JJML_GGML_COMMIT_COUNT} CACHE INTERNAL GGML_BUILD_NUMBER)
 endif()
+if(NOT GGML_VERSION)
+if (JJML_GGML_COMMIT_COUNT)
+set(GGML_VERSION ${GGML_VERSION_MAJOR}.${GGML_VERSION_MINOR}.${GGML_VERSION_PATCH}.${JJML_GGML_COMMIT_COUNT} CACHE INTERNAL GGML_VERSION)
+else()
+set(GGML_VERSION ${GGML_VERSION_MAJOR}.${GGML_VERSION_MINOR}.${GGML_VERSION_PATCH} CACHE INTERNAL GGML_VERSION)
+endif()
+endif()
+
 if(NOT LLAMA_BUILD_NUMBER)
 set(LLAMA_BUILD_NUMBER ${JJML_LLAMA_COMMIT_COUNT} CACHE INTERNAL LLAMA_BUILD_NUMBER)
 endif()
+if(NOT LLAMA_VERSION)
+set(LLAMA_VERSION 0.0.${JJML_LLAMA_COMMIT_COUNT} CACHE INTERNAL LLAMA_VERSION)
+endif()
 
+file(WRITE versions.mk "GGML_VERSION=${GGML_VERSION}\n")
+file(APPEND versions.mk "LLAMA_VERSION=${LLAMA_VERSION}\n")

=== debian/changelog ===
libjjml-java (1.1.18-3) unstable; urgency=medium

  * autopkgtest: Fix detection of skipped tests
  * autopkgtest: Temporarily disable all test models but the smaller ones
  * Remove workaround for dropped dependency on libggml-dev in libllama-dev
  * Introduce CUDA autopkgtest

 -- Mathieu Baudier <mbaudier@argeo.org>  Sun, 18 Jan 2026 14:09:59 +0000

libjjml-java (1.1.18-2) unstable; urgency=medium

  * Introduce autopkgtest support

 -- Mathieu Baudier <mbaudier@argeo.org>  Sat, 10 Jan 2026 15:49:09 +0000

libjjml-java (1.1.18-1) unstable; urgency=medium

  * Upstream release

 -- Mathieu Baudier <mbaudier@argeo.org>  Thu, 18 Dec 2025 19:56:54 +0000

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Mathieu Baudier <mbaudier@argeo.org>
 Standards-Version: 4.7.2
-Vcs-Browser: http://git.argeo.org/?p=argeo-jjml;a=summary
-Vcs-Git: https://git.argeo.org/argeo-jjml
+Vcs-Browser: https://salsa.debian.org/mbaudier/libjjml-java
+Vcs-Git: https://salsa.debian.org/mbaudier/libjjml-java.git
 Homepage: http://git.argeo.org/?p=argeo-jjml;a=summary
 Build-Depends: cmake,
                default-jdk,

=== debian/tests/control ===
Test-Command: debian/tests/java-ea /usr/share/doc/libjjml-java/examples/JjmlSmokeTests.java
Features: test-name=smoke-tests-backend-cpu
Depends: default-jre-headless, libjjml-java
Restrictions: skippable, allow-stderr

Test-Command: debian/tests/gpuisol-test-launcher nvidia debian/tests/java-ea /usr/share/doc/libjjml-java/examples/JjmlSmokeTests.java
Features: test-name=smoke-tests-backend-cuda
Architecture: amd64 arm64 ppc64el
Classes: nvidia-gpu
Depends: default-jre-headless, libjjml-java, libggml0-backend-cuda
Restrictions: skippable, allow-stderr, skip-not-installable
